diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
index cb63be6bc..0276813f0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
@@ -76,19 +76,19 @@ public class BlockLogicRailDetector extends BlockLogicRail {
         if (minecartPresent && !isPowered) {
             // Set rail to powered
             world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.down(new TilePos()), id());
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.down(new TilePos()), this.block);
             world.markBlockDirty(tilePos);
         } else if (!minecartPresent && isPowered) {
             // Set rail to unpowered
             world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.down(new TilePos()), id());
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.down(new TilePos()), this.block);
             world.markBlockDirty(tilePos);
         }
         if (minecartPresent) {
             // Schedule update if minecart in rail
-            world.scheduleBlockUpdate(tilePos, id(), tickDelay());
+            world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
index d8b6957d8..4c3c82a61 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
@@ -35,7 +35,7 @@ public class BlockLogicRedstone extends BlockLogic {
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
         for (Direction dir : Direction.directions) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), this.block);
         }
     }
 
@@ -43,7 +43,7 @@ public class BlockLogicRedstone extends BlockLogic {
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         TilePos queryPos = new TilePos();
         for (Direction dir : Direction.directions) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), this.block);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index f769c2e54..4fc091ab0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -73,12 +73,12 @@ public class BlockLogicRepeater extends BlockLogic {
         int meta = world.getBlockData(tilePos);
         boolean powered = isGettingPower(world, tilePos, meta);
         if (this.isRepeaterPowered && !powered) {
-            world.setBlockIdDataNotify(tilePos, Blocks.REPEATER_IDLE.id(), meta);
+            world.setBlockTypeDataNotify(tilePos, Blocks.REPEATER_IDLE, meta);
         } else if (!this.isRepeaterPowered) {
-            world.setBlockIdDataNotify(tilePos, Blocks.REPEATER_ACTIVE.id(), meta);
+            world.setBlockTypeDataNotify(tilePos, Blocks.REPEATER_ACTIVE, meta);
             if (!powered) {
                 int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
-                world.scheduleBlockUpdate(tilePos, Blocks.REPEATER_ACTIVE.id(), tickDelayMap[tickDelay] * 2);
+                world.scheduleBlockUpdate(tilePos, Blocks.REPEATER_ACTIVE, tickDelayMap[tickDelay] * 2);
             }
         }
     }
@@ -95,7 +95,7 @@ public class BlockLogicRepeater extends BlockLogic {
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         Side back = getSideFromMeta(data);
         Side front = back.getOpposite();
-        world.notifyBlocksOfNeighborChange(tilePos.add(front.getDirection(), new TilePos()), id());
+        world.notifyBlocksOfNeighborChange(tilePos.add(front.getDirection(), new TilePos()), this.block);
     }
 
     @Override
@@ -122,19 +122,19 @@ public class BlockLogicRepeater extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
             return;
         }
         int meta = world.getBlockData(tilePos);
         boolean powered = isGettingPower(world, tilePos, meta);
         int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
         if (this.isRepeaterPowered && !powered) {
-            world.scheduleBlockUpdate(tilePos, id(), tickDelayMap[tickDelay] * 2);
+            world.scheduleBlockUpdate(tilePos, this.block, tickDelayMap[tickDelay] * 2);
         } else if (!this.isRepeaterPowered && powered) {
-            world.scheduleBlockUpdate(tilePos, id(), tickDelayMap[tickDelay] * 2);
+            world.scheduleBlockUpdate(tilePos, this.block, tickDelayMap[tickDelay] * 2);
         }
     }
 
@@ -143,7 +143,7 @@ public class BlockLogicRepeater extends BlockLogic {
         if (direction.isVertical()) return false;
 
         TilePos p = tilePos.add(direction.getDirection(), new TilePos());
-        return world.hasSignal(p, direction) || (world.getBlockId(p) == Blocks.WIRE_REDSTONE.id() && (world.getBlockData(p) & BlockLogicWireRedstone.MASK_POWER) != 0);
+        return world.hasSignal(p, direction) || (world.getBlockType(p) == Blocks.WIRE_REDSTONE && (world.getBlockData(p) & BlockLogicWireRedstone.MASK_POWER) != 0);
     }
 
 
@@ -169,7 +169,7 @@ public class BlockLogicRepeater extends BlockLogic {
         int l = mob.getHorizontalPlacementDirection(side).index;
         world.setBlockDataNotify(tilePos, l);
         if (isGettingPower(world, tilePos, l)) {
-            world.scheduleBlockUpdate(tilePos, id(), 1);
+            world.scheduleBlockUpdate(tilePos, this.block, 1);
         }
     }
 
@@ -179,7 +179,7 @@ public class BlockLogicRepeater extends BlockLogic {
         int l = side.getDirection().index;
         world.setBlockDataNotify(tilePos, l);
         if (isGettingPower(world, tilePos, l)) {
-            world.scheduleBlockUpdate(tilePos, id(), 1);
+            world.scheduleBlockUpdate(tilePos, this.block, 1);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
index 9079469f3..ec32f16f5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
@@ -56,12 +56,12 @@ public class BlockLogicRope
     @Override
     public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        boolean hasBlockNegX = source.getBlockId(tilePos.add(-1, 0, 0, queryPos)) == this.id();
-        boolean hasBlockPosX = source.getBlockId(tilePos.add(1, 0, 0, queryPos)) == this.id();
-        boolean hasBlockNegY = source.getBlockId(tilePos.add(0, -1, 0, queryPos)) == this.id();
-        boolean hasBlockPosY = source.getBlockId(tilePos.add(0, 1, 0, queryPos)) == this.id() || source.isBlockOpaqueCube(tilePos.add(0, 1, 0, queryPos));
-        boolean hasBlockNegZ = source.getBlockId(tilePos.add(0, 0, -1, queryPos)) == this.id();
-        boolean hasBlockPosZ = source.getBlockId(tilePos.add(0, 0, 1, queryPos)) == this.id();
+        boolean hasBlockNegX = source.getBlockType(tilePos.add(-1, 0, 0, queryPos)) == this.block;
+        boolean hasBlockPosX = source.getBlockType(tilePos.add(1, 0, 0, queryPos)) == this.block;
+        boolean hasBlockNegY = source.getBlockType(tilePos.add(0, -1, 0, queryPos)) == this.block;
+        boolean hasBlockPosY = source.getBlockType(tilePos.add(0, 1, 0, queryPos)) == this.block || source.isBlockOpaqueCube(tilePos.add(0, 1, 0, queryPos));
+        boolean hasBlockNegZ = source.getBlockType(tilePos.add(0, 0, -1, queryPos)) == this.block;
+        boolean hasBlockPosZ = source.getBlockType(tilePos.add(0, 0, 1, queryPos)) == this.block;
 
         float minX = 5 / 16.0f;
         float maxX = 11 / 16.0f;
@@ -103,7 +103,7 @@ public class BlockLogicRope
     }
 
     public void pickUpRope(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player) {
-        if (world.isClientSide || world.getBlock(tilePos) != this.block) {
+        if (world.isClientSide || world.getBlockType(tilePos) != this.block) {
             return;
         }
 
@@ -113,7 +113,7 @@ public class BlockLogicRope
         int y = tilePos.y();
         // Find the position of the lowest rope
         while (tilePos.y() > 0) {
-            Block<?> block = world.getBlock(tilePos.down(queryPos));
+            Block<?> block = world.getBlockType(tilePos.down(queryPos));
             if (block != this.block) {
                 break;
             }
@@ -140,7 +140,7 @@ public class BlockLogicRope
             if (ropesCollected >= freeSpace) {
                 break;
             }
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
             ropesCollected++;
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
index 7b699fbe7..b446cf34a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
@@ -40,21 +40,21 @@ public abstract class BlockLogicRotatable extends BlockLogic {
             return;
         }
         TilePos queryPos = new TilePos();
-        int bN = world.getBlockId(tilePos.north(queryPos));
-        int bS = world.getBlockId(tilePos.south(queryPos));
-        int bW = world.getBlockId(tilePos.west(queryPos));
-        int bE = world.getBlockId(tilePos.east(queryPos));
+        final @NotNull Block<?> bN = world.getBlockType(tilePos.north(queryPos));
+        final @NotNull Block<?> bS = world.getBlockType(tilePos.south(queryPos));
+        final @NotNull Block<?> bW = world.getBlockType(tilePos.west(queryPos));
+        final @NotNull Block<?> bE = world.getBlockType(tilePos.east(queryPos));
         Direction direction = Direction.NORTH;
-        if (Blocks.solid[bN] && !Blocks.solid[bS]) {
+        if (bN.solid() && !bS.solid()) {
             direction = Direction.SOUTH;
         }
-        if (Blocks.solid[bS] && !Blocks.solid[bN]) {
+        if (bS.solid() && !bN.solid()) {
             direction = Direction.NORTH;
         }
-        if (Blocks.solid[bW] && !Blocks.solid[bE]) {
+        if (bW.solid() && !bE.solid()) {
             direction = Direction.EAST;
         }
-        if (Blocks.solid[bE] && !Blocks.solid[bW]) {
+        if (bE.solid() && !bW.solid()) {
             direction = Direction.WEST;
         }
         world.setBlockDataNotify(tilePos, setDirection(world.getBlockData(tilePos), direction));
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
index fd717f85d..f30407594 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
@@ -20,13 +20,13 @@ public class BlockLogicSand extends BlockLogic {
     @Override
 	public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos)
     {
-        world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     @Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id)
+	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block)
     {
-        world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
     }
 
     @Override
@@ -39,15 +39,13 @@ public class BlockLogicSand extends BlockLogic {
         if(canFallBelow(world, tilePos.down(queryPos)) && tilePos.y() >= 0) {
             byte radius = 32;
             if(fallInstantly || !world.areBlocksLoaded(tilePos.add(-radius, -radius, -radius, new TilePos()), tilePos.add(radius, radius, radius, new TilePos()))) {
-                world.setBlockIdNotify(tilePos, 0);
-                int checkX = tilePos.x();
-                int checkY = tilePos.y() - 1;
-                int checkZ = tilePos.z();
-                while (canFallBelow(world, queryPos.set(checkX, checkY, checkZ)) && checkY > 0) {
-                    checkY--;
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
+                final @NotNull TilePos check = tilePos.down(new TilePos());
+                while (canFallBelow(world, check) && check.y > 0) {
+                    check.down();
                 }
-                if(checkY > 0) {
-                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
+                if(check.y > 0) {
+                    world.setBlockTypeNotify(check, this.block);
                 }
             } else {
                 EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, tilePos.x() + 0.5, tilePos.y() + 0.5, tilePos.z() + 0.5, this.block.id(), 0, null);
@@ -63,7 +61,7 @@ public class BlockLogicSand extends BlockLogic {
     }
 
     public static boolean canFallBelow(@NotNull World world, @NotNull TilePos tilePos) {
-        Block<?> block = world.getBlock(tilePos);
+        Block<?> block = world.getBlockType(tilePos);
         return block == null || block.hasTag(BlockTags.PLACE_OVERWRITES);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
index 70566c07e..ec896c299 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
@@ -23,8 +23,8 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
     }
 
     @Override
-    public boolean mayPlaceOn(int blockId) {
-        return blockId == Blocks.SAND.id() || super.mayPlaceOn(blockId);
+    public boolean mayPlaceOn(final @NotNull Block<?> block) {
+        return block == Blocks.SAND || super.mayPlaceOn(block);
     }
 
     @Override
@@ -36,8 +36,8 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
         TilePos queryPos = new TilePos();
 
         if (!this.canGrowOnSand) {
-            if (world.getBlockId(tilePos.down(queryPos)) == Blocks.SAND.id()) {
-                world.setBlockIdNotify(tilePos, Blocks.DEADBUSH.id());
+            if (world.getBlockType(tilePos.down(queryPos)) == Blocks.SAND) {
+                world.setBlockTypeNotify(tilePos, Blocks.DEADBUSH);
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
index fa5d545e0..7f301c887 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
@@ -18,12 +18,12 @@ public class BlockLogicSaplingBirch extends BlockLogicSaplingBase {
     @Override
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
 
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
 
         WorldFeature tree = new WorldFeatureTree(Blocks.LEAVES_BIRCH.id(), Blocks.LOG_BIRCH.id(), 5);
 
         if (!tree.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-            world.setBlockId(tilePos, id());
+            world.setBlockType(tilePos, this.block);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
index 6f3846cea..b0763fa0e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
@@ -17,10 +17,10 @@ public class BlockLogicSaplingCacao extends BlockLogicSaplingBase {
     @Override
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
         WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_CACAO.id(), Blocks.LOG_OAK_MOSSY.id(), 4);
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
 
         if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-            world.setBlockId(tilePos, id());
+            world.setBlockType(tilePos, this.block);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
index baa36b440..5331479a7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCherry.java
@@ -19,11 +19,11 @@ public class BlockLogicSaplingCherry extends BlockLogicSaplingBase {
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
         WorldFeature treeBig = new WorldFeatureCherryTreeFancy(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id());
         WorldFeature treeSmall = new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id(), Blocks.LOG_CHERRY.id(), 4);
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
 
         if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
             if (!treeBig.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-                world.setBlockId(tilePos, id());
+                world.setBlockType(tilePos, this.block);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
index 5a5341728..d1ee7e8f4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingEucalyptus.java
@@ -17,12 +17,12 @@ public class BlockLogicSaplingEucalyptus extends BlockLogicSaplingBase {
     @Override
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
 
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
 
         WorldFeature tree = new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id(), Blocks.LOG_EUCALYPTUS.id());
         tree.init(1.0D, 1.0D, 1.0D);
         if (!tree.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-            world.setBlockId(tilePos, id());
+            world.setBlockType(tilePos, this.block);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
index 441e77d3c..e74a51110 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingOak.java
@@ -19,11 +19,11 @@ public class BlockLogicSaplingOak extends BlockLogicSaplingBase {
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
         WorldFeature treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
         WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
 
         if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
             if (!treeBig.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-                world.setBlockId(tilePos, id());
+                world.setBlockType(tilePos, this.block);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
index f6b7351f0..02361d0de 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPalm.java
@@ -18,7 +18,7 @@ public class BlockLogicSaplingPalm extends BlockLogicSaplingBase {
 
     @Override
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
-        boolean big = world.getBlockId(tilePos.down(new TilePos())) != Blocks.SAND.id();
+        boolean big = world.getBlockType(tilePos.down(new TilePos())) != Blocks.SAND;
 
         new WorldFeatureTreePalm(Blocks.LOG_PALM, Blocks.LEAVES_PALM, big, true, false).place(world, random, tilePos.x(), tilePos.y(), tilePos.z());
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
index ce99a00f2..0ee9a00dc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
@@ -38,11 +38,11 @@ public class BlockLogicSaplingPine extends BlockLogicSaplingBase {
         WorldFeature treeBig = new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
         WorldFeature treeSmall = new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
 
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
 
         if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
             if (!treeBig.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-                world.setBlockId(tilePos, id());
+                world.setBlockType(tilePos, this.block);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
index 653b78f5f..6d3858fe7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingRetro.java
@@ -20,11 +20,11 @@ public class BlockLogicSaplingRetro extends BlockLogicSaplingBase {
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
         WorldFeature treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id());
         WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id(), Blocks.LOG_OAK.id(), 4);
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
 
         if (!treeSmall.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
             if (!treeBig.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-                world.setBlockId(tilePos, id());
+                world.setBlockType(tilePos, this.block);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
index a6907c3b7..38dad5469 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingShrub.java
@@ -17,12 +17,12 @@ public class BlockLogicSaplingShrub extends BlockLogicSaplingBase {
     @Override
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
 
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
 
         WorldFeature tree = new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id(), Blocks.LOG_OAK.id());
 
         if (!tree.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-            world.setBlockId(tilePos, id());
+            world.setBlockType(tilePos, this.block);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
index f34a16586..4f835f70a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingThorn.java
@@ -18,11 +18,11 @@ public class BlockLogicSaplingThorn extends BlockLogicSaplingBase {
     @Override
     public void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random) {
 
-        world.setBlockId(tilePos, 0);
+        world.setBlockType(tilePos, Blocks.AIR);
         WorldFeature treeFeature = new WorldFeatureTreeThorn(1, Blocks.LOG_THORN.id(), 0, Blocks.LEAVES_THORN.id(), 0);
 
         if (!treeFeature.place(world, random, tilePos.x(), tilePos.y(), tilePos.z())) {
-            world.setBlockId(tilePos, id());
+            world.setBlockType(tilePos, this.block);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 9fc5376de..dc87952e5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -90,7 +90,7 @@ public class BlockLogicSign extends BlockLogic implements IPaintable {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         TilePos queryPos = new TilePos();
         boolean isUnstable = false;
         if (this.isFreeStanding) {
@@ -108,9 +108,9 @@ public class BlockLogicSign extends BlockLogic implements IPaintable {
         }
         if (isUnstable) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
-        super.onNeighborChanged(world, tilePos, id);
+        super.onNeighborChanged(world, tilePos, block);
     }
 
     @Override
@@ -151,7 +151,7 @@ public class BlockLogicSign extends BlockLogic implements IPaintable {
 
     @Override
     public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
-        world.setBlockIdRaw(tilePos, this.isFreeStanding ? Blocks.SIGN_POST_PLANKS_OAK_PAINTED.id() : Blocks.SIGN_WALL_PLANKS_OAK_PAINTED.id());
+        world.setBlockTypeRaw(tilePos, this.isFreeStanding ? Blocks.SIGN_POST_PLANKS_OAK_PAINTED : Blocks.SIGN_WALL_PLANKS_OAK_PAINTED);
         world.setBlockDataNotify(tilePos, color.blockMeta << 4 | (world.getBlockData(tilePos) & MASK_SIDE));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
index be8881bb9..9dfd95b90 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
@@ -147,8 +147,8 @@ public class BlockLogicSlab extends BlockLogic
     @Override
 	public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
-        return world.getBlockId(tilePos.down(queryPos)) == id() ||
-                world.getBlockId(tilePos.up(queryPos)) == id() ||
+        return world.getBlockType(tilePos.down(queryPos)) == this.block ||
+                world.getBlockType(tilePos.up(queryPos)) == this.block ||
                 super.canPlaceAt(world, tilePos);
     }
 
@@ -189,7 +189,7 @@ public class BlockLogicSlab extends BlockLogic
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        onNeighborChanged(world, tilePos, 0);
+        onNeighborChanged(world, tilePos, Blocks.AIR);
         this.modelBlock.onPlacedByWorld(world, tilePos);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
index fe9294690..c2ef28df4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPaintable.java
@@ -13,7 +13,7 @@ public class BlockLogicSlabPaintable extends BlockLogicSlab implements IPaintabl
     @Override
     public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataNotify(tilePos, Blocks.SLAB_PLANKS_PAINTED.id(), meta);
+        world.setBlockTypeDataNotify(tilePos, Blocks.SLAB_PLANKS_PAINTED, meta);
         Blocks.SLAB_PLANKS_PAINTED.getLogic().setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
index deef4ed75..d9b9cf79b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlabPainted.java
@@ -53,7 +53,7 @@ public class BlockLogicSlabPainted extends BlockLogicSlab implements IPainted
 	@Override
 	public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
 		final int meta = world.getBlockData(tilePos);
-		world.setBlockIdDataNotify(tilePos, Blocks.PLANKS_OAK.id(), meta & 0xF);
+		world.setBlockTypeDataNotify(tilePos, Blocks.PLANKS_OAK, meta & 0xF);
 	}
 
 	@Override
